Description

the functions EvalArgAsT1OrT2OrT3... modify the last argument (int) giving 1 or 2 or 3...

the functions EvalArgAsT1OrT2 modifies the last argument (bool) giving isFirst

Should we change EvalArgAsT1OrT2 so that it behaves like the others?

It would be a good idea, but it is extremely delicate work because of silent conversions between int and bool.

2014-08 done: last arg in all functions now is int (usually called which)

Related issues:

Related to CoCoA-5 - Feature #384: IsZero for matrix Closed 05 Jul 2013

Related to CoCoA-5 - Support #296: Documentation for Parser/Interpreter In Progress 24 Jan 2013

Related to CoCoA-5 - Design #294: BuiltInFunctions: General "OneLiner" for ar... Closed 23 Jan 2013

Related to CoCoALib - Support #452: Documentation for adding functions to CoC... Closed 01 Mar 2014

History

#1 - 08 Apr 2014 11:02 - John Abbott

I like the idea of making them all "compatible".

Another option would be to have an enum with one value for each type, and the function returns the enum value corresponding to the type actually

found.  This would make the order of the types in the template irrelevant:

TypeEnum ActualType;

auto arg1 = EvalAsT1OrT2OrT3<BigInt, BigRat, RingElem>(ARG(1), ActualType);

switch (ActualType)

{

  case BigIntType: ...

  case BigRatType: ...

  case RingElemType: ...

}

I don't guarantee that this could be realised...

#2 - 15 Jul 2014 11:02 - Anna Maria Bigatti

- Subject changed from BuiltInFunctions: EvalArgAsT1OrT2 to BuiltInFunctions: evalArgAsT1OrT2
- Category changed from Parser/Interpreter to Cleaning

- Status changed from New to Resolved

- Assignee set to Anna Maria Bigatti

- % Done changed from 0 to 80

We agreed that it would be handy to have the same interface for

evalArgAsT1orT2 and evalArgAsT1orT2orT3.

The last argument of evalArgAsT1orT2 is the bool isT1, whereas in the new view it should be an int which: this is the situation

isT1=true  would give which=1, that is T1

isT1=false would give which=0, that is invalid, but it usually used as !isT1, that is T2.

HOWEVER I left a non-implemented version with bool so that passing bool instead of int would not link.

All done: it works

#3 - 15 Jul 2014 12:27 - Anna Maria Bigatti

- Status changed from Resolved to Feedback

- % Done changed from 80 to 90

cvs-ed

#4 - 27 Aug 2014 18:09 - Anna Maria Bigatti

- Tracker changed from Bug to Design

- Subject changed from BuiltInFunctions: evalArgAsT1OrT2 to BuiltInFunctions: evalArgAsT1OrT2, evalArgAsT1OrT2OrT3, ... last argument

- Status changed from Feedback to Closed

- % Done changed from 90 to 100

Powered by TCPDF (www.tcpdf.org)

20 Apr 2024 2/2

http://www.tcpdf.org

